<?php
/**
 * @package Tabaoca.Administrator
 * @subpackage com_gabble
 * @copyright (C) 2023 Jonatas C. Ferreira
 * @license GNU/AGPL v3 (see licence.txt)
 */

defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\Factory;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Uri\Uri;

$app = Factory::getApplication();
$session = $app->getSession();

?>

<div class="container">

	<div id="btn_start" class="btn btn-success" onclick="setup_admin(); this.hidden = true; document.getElementById('data_gabble').removeAttribute('hidden');">Start</div>

	<div id="data_gabble" class="row" hidden="">

		<div class="col-md-8">

			<div class="row">

				<div class="col-md-6">
					<div class="box_data">
						<span class="title_data"><i class="icon-users"></i><b> <?php echo Text::_('COM_GABBLE_USERS_ON');?></b></span>
						<div class="field_data">
							<span id="users_on"></span><span id="users"></span>
						</div>
					</div>
				</div>

				<div class="col-md-6">
					<div class="box_data">
						<span class="title_data"><i class="icon-comments-2"></i><b> <?php echo Text::_('COM_GABBLE_CHATS');?></b></span>
						<div class="field_data">
							<span id="feeds"></span>
						</div>
					</div>
				</div>

				<div class="col-md-6">
					<div class="box_data">
						<span class="title_data"><i class="icon-comments"></i><b> <?php echo Text::_('COM_GABBLE_MESSAGES');?></b></span>
						<div class="field_data">
							<span id="messages"></span>
						</div>
					</div>
				</div>

				<div class="col-md-6">
					<div class="box_data">
						<span class="title_data">
							<img src="<?php echo Uri::root(); ?>media/com_gabble/images/logo_openai.png" class="openai_logo_sm" alt="OpenAI GPT">
							<b><?php echo Text::_('COM_GABBLE_MESSAGES_GPT');?></b>
						</span>
						<div class="field_data">
							<span id="messages_gpt"></span>
						</div>
					</div>
				</div>

			</div>

		</div>

		<div class="col-md-4">

		</div>

	</div>

	<input type="hidden" id="uri_base" value="<?php echo Uri::base(); ?>">
	<input type="hidden" id="token" value="<?php echo $session->getFormToken(); ?>">

</div>

<p style="text-align:right;" ><?php echo Text::_('COM_GABBLE_POWERED');?> <a href="https://tabaoca.org">Tabaoca</a></p>
